# Mammogram Image Analysis Using GPZM and KM

## Image source
The dataset and its metadata can be accessed from CBIS-DDSM website at https://wiki.cancerimagingarchive.net/display/Public/CBIS-DDSM.

The metadata of the dataset can be retrieved directly by following the sequence below:
CBIS-DDSM website > Data Access > Mass-Training-Description (csv) > Download
CBIS-DDSM website > Data Access > Mass- Test-Description (csv) > Download

The breast cancer images can be retrieved by following the sequence below:
CBIS-DDSM website > Detailed Description > Mass-Training ROI and Cropped Images (DICOM) > Download
CBIS-DDSM website > Detailed Description > Mass-Test ROI and Cropped Images (DICOM) > Download

For the breast cancer images, clicking the "Download" button will save a ".tcia" manifest file that can only be opened with the NBIA Data Retriever. 
To download the NBIA Data Retriever, please follow the instructions in this link: https://wiki.cancerimagingarchive.net/display/NBIA/Downloading+TCIA+Images

#download links
The database can be accessed using the following link:
https://wiki.cancerimagingarchive.net/display/Public/CBIS-DDSM#225166295e40bd1f79d64f04b40cac57ceca9272

The images can be downloaded from the following links:
- https://wiki.cancerimagingarchive.net/download/attachments/22516629/Mass-Test_ROI-mask_and_crpped_images-doiJNLP-SmEOyQFn.tcia?version=1&modificationDate=1534787719824&api=v2
- https://wiki.cancerimagingarchive.net/download/attachments/22516629/Mass-Training_ROI-mask_and_crpped_images_1-doiJNLP-07gmVj4b.tcia?version=1&modificationDate=1534787720507&api=v2

The description for each images can be downloaded from the following links:
- https://wiki.cancerimagingarchive.net/download/attachments/22516629/mass_case_description_train_set.csv?version=1&modificationDate=1506796355038&api=v2
- https://wiki.cancerimagingarchive.net/download/attachments/22516629/mass_case_description_test_set.csv?version=1&modificationDate=1506796343175&api=v2

## Abnormality type
The abnormality type used for this project are as follows:
well-defined/circumscribed mass, spiculated mass, ill-defined mass, architectural distortion, and asymmetry

## Seed Numbers
The seeds used for this experiment are:
3, 261, 303, 399, 440, 474, 564, 657, 705, 744

## Flow of codes to run
The scripts are run in a Linux environment.

The flow of using the codes are as follows:
1. Run gpzm_finalCode.r (GPZM) and krawt_finalCode.r (KM) on image folder. Note: change foldername and filename accordingly.
2. (not included) Combine the data from step 1 and remove all columns with only 0. Save it as tab_all.txt.
The Figshare link to this file (~700MB) is at https://figshare.com/s/4706bc975908358d4c23
3. Run code1.r for feature selection and split 70:30 ratio. (Rscript code1.r seed_no) (i.e. Rscript code1.r 3)
4. Run expert_features.r to generate LDA variable for GPZM and KM. (Rscript expert_features.r seed_no) (i.e. Rscript expert_features.r 3)
5. Run magic.in using GUIDE. (./guide < magic.in)
6. Run expert_combine.r
7. Run mergedat_without_both.in using GUIDE. (./guide < mergedat_without_both.in)
8. Run mergedat_without_prob.in using GUIDE. (/guide < mergedat_without_prob.in)
9. Run mergedat_without_birads.in using GUIDE. (./guide < mergedat_without_birads.in)
10. Run mergedat_use_both.in using GUIDE. (./guide < mergedat_use_both.in)
