
file <- list.files()
file <- file[grep("result_",file)]

args = commandArgs(trailingOnly=TRUE)

fname <- paste(file,"/",args[1],".out",sep="")

fileresult <- lapply(fname,readLines)

trainingname <- lapply(fileresult,function(x)(grep("Classification matrix for training sample",x)))

testname <- lapply(fileresult,function(x)(grep("Classification matrix for test sample",x)))

getResult <- function(n,folder,pos){
  res <- folder[[n]]
  p <- pos[[n]]
  y <- res[(p+3):(p+4)]
  y1 <- unlist(strsplit(y,"\\s+"))
  y1 <- y1[c(3,4,7,8)]
}

training <- lapply(1:length(trainingname),getResult,fileresult,trainingname)
test <- lapply(1:length(testname),getResult,fileresult,testname)

training.tab <- do.call(rbind,training)
test.tab <- do.call(rbind,test)

training.tab <- apply(training.tab,2,as.numeric)
test.tab <- apply(test.tab,2,as.numeric)

rownames(training.tab) <- file
rownames(test.tab) <- file

colnames(training.tab) <- c("oo","ol","lo","ll")
colnames(test.tab) <- c("oo","ol","lo","ll")

training.tab <- data.frame(training.tab)
test.tab <- data.frame(test.tab)

test.tab$acc <- (test.tab$oo+test.tab$ll)/(test.tab$oo+test.tab$ol+test.tab$lo+test.tab$ll)
test.tab$sen <- (test.tab$ll)/(test.tab$ol+test.tab$ll)
test.tab$spe <- (test.tab$oo)/(test.tab$oo+test.tab$lo)

write.table(test.tab,paste("test_",args[1],".txt",sep=""))
